package com.displaynone.acss.ui.admin

import android.util.Log
import androidx.lifecycle.ViewModel
import androidx.lifecycle.viewModelScope
import com.displaynone.acss.components.auth.models.user.UserServiceST
import com.displaynone.acss.components.auth.models.user.repository.dto.UserDTO
import com.displaynone.acss.ui.profile.ProfileViewModel.State
import kotlinx.coroutines.flow.MutableStateFlow
import kotlinx.coroutines.flow.asStateFlow
import kotlinx.coroutines.launch

class AdminViewModel: ViewModel() {
    val _state = MutableStateFlow<State>(State.Loading)
    val state = _state.asStateFlow()
    fun getDataByLogin(login: String){
        viewModelScope.launch {
            UserServiceST.getInstance().getInfoByLogin(login).fold(
                onSuccess = { dto ->
                    _state.emit(State.Show(item = dto))
                },
                onFailure = { error ->
                    error.message?.let { error(it) }
                    Log.e("AdminViewModel", error.message.toString()) }
            )
        }
    }

    sealed interface State {
        data class Show(
            val item: UserDTO
            ): State
        data object Loading : State
    }
}